# Data Source & Key Vault

Lab Objective:
- Use data sources to obtain user data
- Create a key vault to protect a database password
- Update database resource to use secured password

## Preparation

If you did not complete lab 3.4, you can simply copy the solution code from that lab (and do terraform apply) as the starting point for this lab.

## Lab

### Add Data Sources

Access to the key vault we will create shortly requires an access policy allowing your user to write and read secrets in the vault.  The access policy will require a couple bits of information about your user that we will need to read from data sources.  

One of the data sources we will use requires a new provider "azuread".  Open "main.tf" and add "azuread" to the required_providers sub-block and as a new provider block:

```
terraform {
  required_providers {

    ...

    azuread = {
      source = "hashicorp/azuread"
      version = "~> 2.47"
    }
  }

  ...

}

...

provider "azuread" {
  use_msi = false
}
```

Now create a new file `vault.tf` to provided Terraform blocks are part of a configuration that involves Azure resources and services, including data retrieval, password generation, and secure storage using Azure Key Vault. Each block plays a specific role in the setup and security of infrastructure components.

### Data Sources

In this new file, add two data sources.  The first data source reads information about your user accessing the Azure resource manager.  The second data source reads information from Active Directory about a group your user is a member of.

```
data "azurerm_client_config" "current" {}

data "azuread_group" "lab" {
  display_name = "Students"
}
```

**`azurerm_client_config`**:
   - **Type**: `data`
   - **Name**: `current`
   - **Purpose**: Retrieves the configuration details of the provider used within the Terraform configuration, specifically the Azure tenant ID. This is useful for configurations that require knowledge of the tenant context, such as when setting up resources that depend on the Azure Active Directory or tenant-specific details.

**`azuread_group`**:
   - **Type**: `data`
   - **Name**: `lab`
   - **Configuration**:
     - `display_name`: Specifies the display name of the Azure AD group to retrieve, in this case, "Students".
   - **Purpose**: Retrieves information about an Azure AD group. This is useful for configurations that require group details, such as setting permissions based on group membership.

### Resources

#### Create Key Vault

We can now declare the resources for a key vault.

Add three new resources to the "vault.tf" file:

1. A random password that will be the new database password.

```
resource "random_password" "dbpassword" {
  length           = 16
  min_numeric      = 1
  special          = true
  override_special = "_%#"
}
```

**`random_password`**:
   - **Type**: `resource`
   - **Name**: `dbpassword`
   - **Configuration**:
     - `length`: Sets the length of the generated password to 16 characters.
     - `min_numeric`: Ensures that at least one character is numeric.
     - `special`: Indicates that special characters are included in the password.
     - `override_special`: Specifies which special characters are allowed, in this case, "_%#".
   - **Purpose**: Generates a secure random password for use, potentially in configurations where secure credentials are needed, such as database passwords.

2. A key vault to hold secrets.  Notice the references to the data sources.

```
resource "azurerm_key_vault" "lab" {
  name                = "aztf-key-vault-${random_integer.suffix.result}"
  location            = local.region
  resource_group_name = local.resource_group
  tenant_id           = data.azurerm_client_config.current.tenant_id

  sku_name = "standard"

  access_policy {
    tenant_id = data.azurerm_client_config.current.tenant_id
    object_id = data.azuread_group.lab.object_id
    secret_permissions = [
      "Get",
      "Set",
      "Delete",
      "Purge",
      "List"
    ]
  }

  tags = local.common_tags
}
```

**`azurerm_key_vault`**:
   - **Type**: `resource`
   - **Name**: `lab`
   - **Configuration**:
     - `name`: The name of the Key Vault, including a dynamic suffix generated by `random_integer.suffix.result` to ensure uniqueness.
     - `location`: Uses a local variable to specify the Azure region.
     - `resource_group_name`: Specifies the resource group where the Key Vault will be located, using a local variable.
     - `tenant_id`: The Azure tenant ID retrieved from the `azurerm_client_config`.
     - `sku_name`: Specifies the SKU for the Key Vault; here, it is set to "standard".
     - `access_policy`: Configures access policies for the Key Vault:
       - `tenant_id`: Tenant ID, repeated for clarity within the policy context.
       - `object_id`: Object ID of the Azure AD group "Students", allowing this group specific permissions.
       - `secret_permissions`: Lists the permissions granted to the group regarding secret management, including get, set, delete, purge, and list operations.
   - **Purpose**: Provides a secure location to manage and access secrets like passwords or certificates, leveraging Azure's managed service for handling cryptographic keys and other secrets.

3. A key vault secret for the generated random password

```
resource "azurerm_key_vault_secret" "lab-db-pwd" {
  name         = "dbpassword"
  value        = random_password.dbpassword.result
  key_vault_id = azurerm_key_vault.lab.id
}
```
**`azurerm_key_vault_secret`**:
   - **Type**: `resource`
   - **Name**: `lab-db-pwd`
   - **Configuration**:
     - `name`: The name of the secret stored in the Key Vault, in this case, "dbpassword".
     - `value`: The generated password from the `random_password` resource.
     - `key_vault_id`: The identifier for the Key Vault where this secret is stored.
   - **Purpose**: Stores the generated database password securely in Azure Key Vault, ensuring that sensitive information is managed and accessed securely.

These Terraform blocks collectively set up a robust and secure infrastructure for managing sensitive information like database passwords within Azure. Using Azure Key Vault in conjunction with Azure AD groups and generated secrets ensures that access to sensitive data is controlled and auditable, adhering to best practices for cloud security and compliance. This setup is particularly useful in scenarios requiring strict access controls and automated management of credentials and secrets.

Since one of data sources uses a new provider "azuread", you must run terraform init:

```shell
terraform init
```

Run terraform validate to make sure you have no errors:

```shell
terraform validate
```

Run terraform plan:

```shell
terraform plan
```

Run terraform apply.  The key vault might take a couple minutes to create.

```shell
terraform apply
```

![Terraform - Apply vault addition](./images/tf-apply-vault.png "Terraform - Apply vault addition")

Let's now see that Terraform treats a random password resource as a sensitive value. Run the following to verify that the value is not actually shown and is displayed as “(sensitive value)”.  This ensures that the secure password does not leak into logs.

```shell
terraform state show azurerm_key_vault_secret.lab-db-pwd
terraform state show random_password.dbpassword
```

![Terraform - Show state](./images/tf-state-show.png "Terraform - Show state")

### Viewing Results in Azure Portal

Let’s now confirm the secret was created in Azure.

Go to the Azure Portal.  Type “vault” and select the “Key vaults” auto-suggestion.

![Azure Portal - Vault](./images/az-vault.png "Azure Portal - Vault")

Click on the key vault.

![Azure Portal - Key Vault](./images/az-key-vault.png "Azure Portal - Key Vault")

Click on Secrets to confirm your database password secret was created.

![Azure Portal - Vault Secret](./images/az-secret.png "Azure Portal - Vault Secret")

### Update Database to use Secure Password

We now want to use this secure password for the database.

Open the “database.tf” file.

For the “administrator_login_password” argument, use the following for the value:  <code>azurerm_key_vault_secret.lab-db-pwd.value</code>

![Terraform - Change DB password](./images/tf-change-pw.png "Terraform - Change DB password")

Run terraform plan.  Note that the database server will be updated in place and does not need to be re-created.

```shell
terraform plan
```

![Terraform Plan - Key vault](./images/tf-plan-key-vault.png "Terraform Plan - Key vault")

Run terraform apply

```shell
terraform apply
```

![Terraform - Apply DB pw change](./images/tf-apply-change-pw.png "Terraform - Apply DB pw change")

:bangbang: NOTE: Using credentials stored in a key vault helps secure the database.  Applications that need to access the database should use provisioning logic to extract the password from the vault and inject it into the application.  Although the password in the vault can be revealed to privileged users, the password should not be saved in files on an application server.

---

### Summary

#### Lab Objective:
The primary goal of this lab is to integrate secure management of sensitive data using Azure Key Vault, leveraging data sources for dynamic configuration and enhancing security practices within the Terraform-managed infrastructure.

#### Preparation:
Participants are advised to start with the configurations established in lab 3.4 or copy its solution code to ensure they have a consistent foundation for this lab.

#### Lab Steps:

### Step 1: Configure Providers and Data Sources
- **Provider Configuration**:
  - Add the "azuread" provider to handle Azure Active Directory resources, necessary for retrieving group details and managing access policies related to Azure AD.
  
- **Data Sources Setup**:
  - **Azure RM Client Config**: Fetches current Azure tenant details needed for configuring resources that are tenant-specific.
  - **Azure AD Group**: Retrieves details about the "Students" group which will be used to configure access policies in Azure Key Vault.

### Step 2: Key Vault Setup
- **Key Vault Configuration**:
  - Create a secure vault for storing secrets, such as database passwords, with access policies that restrict access to specified Azure AD groups and user accounts.
  
- **Resources Created**:
  1. **Random Password**: Generates a secure password that will be used for the database.
  2. **Azure Key Vault**: Configures a vault with access policies leveraging the data sourced from Azure AD and Azure RM.
  3. **Key Vault Secret**: Stores the generated password in the vault, ensuring it is managed securely.

### Step 3: Validate and Apply Configuration
- **Commands Executed**:
  - `terraform init`: Initializes the Terraform configuration, loading new providers as necessary.
  - `terraform validate`: Checks for configuration errors.
  - `terraform plan`: Outputs the planned operations without applying any changes.
  - `terraform apply`: Applies the configuration changes to Azure, setting up the Key Vault and storing the password securely.

### Step 4: Integration with Database
- **Database Password Update**:
  - Update the database configuration to use the secured password from the Key Vault, demonstrating how to integrate secured secrets into actual resource deployments.

### Step 5: Verifications
- **Terraform State Inspection**:
  - Commands like `terraform state show` are used to verify that the password value is treated as sensitive and isn't exposed in the logs or command outputs.
  
- **Azure Portal Verification**:
  - Participants are guided to check the Azure Portal to confirm the creation of the Key Vault and the storage of the secret.

### Educational Outcomes:
- **Security Practices**: Participants learn about best practices for managing sensitive information using Azure Key Vault and how to automate this process using Terraform.
- **Dynamic Data Fetching**: Demonstrates the use of data sources to dynamically fetch and utilize data within Terraform configurations, enhancing flexibility and security.
- **Practical Application**: Shows a practical application of using managed secrets in real-world scenarios, such as configuring a database with a secure password.

#### Conclusion:
This lab provides a comprehensive approach to managing sensitive configurations securely, using Azure Key Vault integrated within a Terraform-managed infrastructure. It emphasizes security best practices, automation, and the dynamic use of data within cloud environments, equipping participants with the skills to handle sensitive data effectively in their future projects.